/***************************************************************************
                          LCD.cpp  -  description
                             -------------------
    begin                : Sat Nov 24 2001
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "QLED.h"

#include <qpixmap.h>

QLED::QLED( QWidget *parent, const char *name,  WFlags f )
	: QLabel( parent, name, f )
{
	Ptr = NULL;
}

QLED::~QLED()
{
}

void QLED::mousePressEvent( QMouseEvent* event )
{
	bool hit = hitLED( event->pos() );
	if ( hit ) {
		if( event->button() == LeftButton )	{			
			emit lclicked();
		}
		if( event->button() == RightButton )	{			
			emit rclicked();
		}		
	}
}


bool QLED::hitLED( const QPoint &pos ) const
{
    return rect().contains( pos );
}

void QLED::paintEvent ( QPaintEvent* event )
{
    QPainter p(this);
    p.setClipRect(event->rect());
    QPixmap *x, xScaled;
    int xPos, yPos, compare;
      
    x = pixmap();
    xPos = 0;
    yPos = 0;
    
    if ( x->size() == size() ) {
      bitBlt( this, 0, 0, x );
    } else {
      QWMatrix m;
      compare = height() <= width() ? height() : width();
      m.scale((double)compare/x->width(),
         (double)compare/x->height());
      xScaled = x->xForm(m);
      if ( xScaled.width() != width() )
      {
          xPos = (width() - xScaled.width())/2;
      }
      if ( xScaled.height() != height() )
      {
          yPos = (height() - xScaled.height())/2;
      }      
      bitBlt( this, xPos, yPos, &xScaled );
    }
}
