/***************************************************************************
                          clientsocket.h  -  description
                             -------------------
    begin                : Sat Sep 14 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CLIENTSOCKET_H
#define CLIENTSOCKET_H

/**
  *@author Ivica Bukvic
  */

#include <qsocket.h>

/*
  The ClientSocket class provides a socket that is connected with a client.
  For every client that connects to the server, the server creates a new
  instance of this class.
*/

class ClientSocket : public QSocket
{
    Q_OBJECT
public:
    ClientSocket( int sock, QObject *parent=0, int id_num=0, const char *name=0 );
    ~ClientSocket();

    int line;
    int ID;
    QString str;
    bool checkAuth;

private slots:
    void readClient();
    void writeClient( QString );
    void connectionClosed();
    void sendBadAuth();

signals:
    void Incoming( int, QString );
    void Receiving( bool );
    void Sending( bool );
    void Closing();
    void BadAuth( int );
};

#endif
