/***************************************************************************
                          externaltimer.cpp  -  description
                             -------------------
    begin                : Fri Aug 30 2002
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "externaltimer.h"

#include <qlabel.h>
#include <qlcdnumber.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

/* 
 *  Constructs a ExternalTimer which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
ExternalTimer::ExternalTimer( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
 	QPixmap image0;
	image0.load("/usr/local/rtmix/images/leftedge.xpm", NULL, DiffuseAlphaDither);
    QPixmap image1;
	image1.load("/usr/local/rtmix/images/rightedge.xpm", NULL, DiffuseAlphaDither);

    if ( !name )
	setName( "External Timer" );
    resize( 620, 151 );
	setMinimumSize( 620, 151 );
	setMaximumSize( 620, 151 );
    setCaption( tr( "External Timer" ) );

    cg.setColor( QColorGroup::Foreground, QColor( 85, 255, 0) );
    cg.setColor( QColorGroup::Button, QColor( 85, 255, 0) );
    cg.setColor( QColorGroup::Light, QColor( 170, 255, 127) );
    cg.setColor( QColorGroup::Midlight, QColor( 127, 255, 63) );
    cg.setColor( QColorGroup::Dark, QColor( 42, 127, 0) );
    cg.setColor( QColorGroup::Mid, QColor( 57, 170, 0) );
    cg.setColor( QColorGroup::Text, white );
    cg.setColor( QColorGroup::BrightText, white );
    cg.setColor( QColorGroup::ButtonText, white );
    cg.setColor( QColorGroup::Base, black );
    cg.setColor( QColorGroup::Background, black );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    pal.setInactive( cg );
    pal.setDisabled( cg );

	HourMinuteColumn = new QLCDNumber( this, "HourMinuteColumn");
    HourMinuteColumn->setGeometry( QRect( 135, 5, 40, 121 ) );
    HourMinuteColumn->setPalette( pal );
    HourMinuteColumn->setCursor( QCursor( 0 ) );
    HourMinuteColumn->setMouseTracking( FALSE );
    HourMinuteColumn->setFocusPolicy( QLCDNumber::NoFocus );
    HourMinuteColumn->setAcceptDrops( FALSE );
    HourMinuteColumn->setAutoMask( FALSE );
    HourMinuteColumn->setFrameShape( QLCDNumber::NoFrame );
    HourMinuteColumn->setFrameShadow( QLCDNumber::Plain );
    HourMinuteColumn->setLineWidth( 2 );
    HourMinuteColumn->setMargin( 0 );
    HourMinuteColumn->setMidLineWidth( 0 );
    HourMinuteColumn->setSmallDecimalPoint( FALSE );
    HourMinuteColumn->setNumDigits( 1 );
    HourMinuteColumn->setMode( QLCDNumber::DEC );
    HourMinuteColumn->setSegmentStyle( QLCDNumber::Filled );
	HourMinuteColumn->display( ":" );

    MinuteSecondColumn = new QLCDNumber( this, "MinuteSecondColumn" );
    MinuteSecondColumn->setGeometry( QRect( 305, 5, 40, 121 ) );
    MinuteSecondColumn->setPalette( pal );
    MinuteSecondColumn->setCursor( QCursor( 0 ) );
    MinuteSecondColumn->setMouseTracking( FALSE );
    MinuteSecondColumn->setFocusPolicy( QLCDNumber::NoFocus );
    MinuteSecondColumn->setAcceptDrops( FALSE );
    MinuteSecondColumn->setAutoMask( FALSE );
    MinuteSecondColumn->setFrameShape( QLCDNumber::NoFrame );
    MinuteSecondColumn->setFrameShadow( QLCDNumber::Plain );
    MinuteSecondColumn->setLineWidth( 2 );
    MinuteSecondColumn->setMargin( 0 );
    MinuteSecondColumn->setMidLineWidth( 0 );
    MinuteSecondColumn->setSmallDecimalPoint( FALSE );
    MinuteSecondColumn->setNumDigits( 1 );
    MinuteSecondColumn->setMode( QLCDNumber::DEC );
    MinuteSecondColumn->setSegmentStyle( QLCDNumber::Filled );
	MinuteSecondColumn->display( ":" );

    SecondCentisecondDot = new QLCDNumber( this, "SecondCentisecondDot" );
    SecondCentisecondDot->setGeometry( QRect( 475, 5, 30, 121 ) );	
    SecondCentisecondDot->setPalette( pal );
    SecondCentisecondDot->setCursor( QCursor( 0 ) );
    SecondCentisecondDot->setMouseTracking( FALSE );
    SecondCentisecondDot->setFocusPolicy( QLCDNumber::NoFocus );
    SecondCentisecondDot->setAcceptDrops( FALSE );
    SecondCentisecondDot->setAutoMask( FALSE );
    SecondCentisecondDot->setFrameShape( QLCDNumber::NoFrame );
    SecondCentisecondDot->setFrameShadow( QLCDNumber::Plain );
    SecondCentisecondDot->setLineWidth( 2 );
    SecondCentisecondDot->setMargin( 0 );
    SecondCentisecondDot->setMidLineWidth( 0 );
    SecondCentisecondDot->setSmallDecimalPoint( FALSE );
    SecondCentisecondDot->setNumDigits( 1 );
    SecondCentisecondDot->setMode( QLCDNumber::DEC );
    SecondCentisecondDot->setSegmentStyle( QLCDNumber::Filled );
	SecondCentisecondDot->display( "." );

    TimerLeftEdge = new QLabel( this, "TimerLeftEdge" );
    TimerLeftEdge->setGeometry( QRect( 5, 5, 10, 121 ) );
    TimerLeftEdge->setMinimumSize( QSize( 10, 0 ) );
    TimerLeftEdge->setMaximumSize( QSize( 10, 32767 ) );
    TimerLeftEdge->setPixmap( image0 );
    TimerLeftEdge->setScaledContents( TRUE );

    TimerRightEdge = new QLabel( this, "TimerRightEdge" );
    TimerRightEdge->setEnabled( TRUE );
    TimerRightEdge->setGeometry( QRect( 605, 5, 10, 121 ) ); 
    TimerRightEdge->setMinimumSize( QSize( 10, 0 ) );
    TimerRightEdge->setMaximumSize( QSize( 10, 32767 ) );
    TimerRightEdge->setPixmap( image1 );
    TimerRightEdge->setScaledContents( TRUE );

    NHour = new QLCDNumber( this, "NHour" );
    NHour->setGeometry( QRect( 15, 5, 120, 121 ) ); 
    NHour->setMinimumSize( QSize( 120, 110 ) );
    NHour->setPalette( pal );
    NHour->setCursor( QCursor( 0 ) );
    NHour->setMouseTracking( FALSE );
    NHour->setFocusPolicy( QLCDNumber::NoFocus );
    NHour->setAcceptDrops( FALSE );
    NHour->setAutoMask( FALSE );
    NHour->setFrameShape( QLCDNumber::NoFrame );
    NHour->setFrameShadow( QLCDNumber::Plain );
    NHour->setLineWidth( 2 );
    NHour->setMargin( 0 );
    NHour->setMidLineWidth( 0 );
    NHour->setSmallDecimalPoint( FALSE );
    NHour->setNumDigits( 2 );
    NHour->setSegmentStyle( QLCDNumber::Filled );
    NHour->setProperty( "intValue", 0 );

    NMinute = new QLCDNumber( this, "NMinute" );
    NMinute->setGeometry( QRect( 240, 5, 65, 121 ) ); 
    NMinute->setMinimumSize( QSize( 65, 110 ) );
    pal.setDisabled( cg );
    NMinute->setPalette( pal );
    NMinute->setCursor( QCursor( 0 ) );
    NMinute->setMouseTracking( FALSE );
    NMinute->setFocusPolicy( QLCDNumber::NoFocus );
    NMinute->setAcceptDrops( FALSE );
    NMinute->setAutoMask( FALSE );
    NMinute->setFrameShape( QLCDNumber::NoFrame );
    NMinute->setFrameShadow( QLCDNumber::Plain );
    NMinute->setLineWidth( 2 );
    NMinute->setMargin( 0 );
    NMinute->setMidLineWidth( 0 );
    NMinute->setSmallDecimalPoint( FALSE );
    NMinute->setNumDigits( 1 );
    NMinute->setSegmentStyle( QLCDNumber::Filled );
    NMinute->setProperty( "intValue", 0 );

    NTenSecond = new QLCDNumber( this, "NTenSecond" );
    NTenSecond->setGeometry( QRect( 345, 5, 65, 121 ) ); 
    NTenSecond->setMinimumSize( QSize( 65, 110 ) );
    NTenSecond->setPalette( pal );
    NTenSecond->setCursor( QCursor( 0 ) );
    NTenSecond->setMouseTracking( FALSE );
    NTenSecond->setFocusPolicy( QLCDNumber::NoFocus );
    NTenSecond->setAcceptDrops( FALSE );
    NTenSecond->setAutoMask( FALSE );
    NTenSecond->setFrameShape( QLCDNumber::NoFrame );
    NTenSecond->setFrameShadow( QLCDNumber::Plain );
    NTenSecond->setLineWidth( 2 );
    NTenSecond->setMargin( 0 );
    NTenSecond->setMidLineWidth( 0 );
    NTenSecond->setSmallDecimalPoint( FALSE );
    NTenSecond->setNumDigits( 1 );
    NTenSecond->setSegmentStyle( QLCDNumber::Filled );
    NTenSecond->setProperty( "intValue", 0 );

    NSecond = new QLCDNumber( this, "NSecond" );
    NSecond->setGeometry( QRect( 410, 5, 65, 121 ) ); 
    NSecond->setMinimumSize( QSize( 65, 110 ) );
    NSecond->setPalette( pal );
    NSecond->setCursor( QCursor( 0 ) );
    NSecond->setMouseTracking( FALSE );
    NSecond->setFocusPolicy( QLCDNumber::NoFocus );
    NSecond->setAcceptDrops( FALSE );
    NSecond->setAutoMask( FALSE );
    NSecond->setFrameShape( QLCDNumber::NoFrame );
    NSecond->setFrameShadow( QLCDNumber::Plain );
    NSecond->setLineWidth( 2 );
    NSecond->setMargin( 0 );
    NSecond->setMidLineWidth( 0 );
    NSecond->setSmallDecimalPoint( FALSE );
    NSecond->setNumDigits( 1 );
    NSecond->setSegmentStyle( QLCDNumber::Filled );
    NSecond->setProperty( "intValue", 0 );

    NTenCentisecond = new QLCDNumber( this, "NTenCentisecond" );
    NTenCentisecond->setGeometry( QRect( 505, 5, 50, 121 ) ); 
    NTenCentisecond->setMinimumSize( QSize( 50, 110 ) );
    NTenCentisecond->setPalette( pal );
    NTenCentisecond->setCursor( QCursor( 0 ) );
    NTenCentisecond->setMouseTracking( FALSE );
    NTenCentisecond->setFocusPolicy( QLCDNumber::NoFocus );
    NTenCentisecond->setAcceptDrops( FALSE );
    NTenCentisecond->setAutoMask( FALSE );
    NTenCentisecond->setFrameShape( QLCDNumber::NoFrame );
    NTenCentisecond->setFrameShadow( QLCDNumber::Plain );
    NTenCentisecond->setLineWidth( 1 );
    NTenCentisecond->setMargin( 0 );
    NTenCentisecond->setMidLineWidth( 0 );
    NTenCentisecond->setSmallDecimalPoint( FALSE );
    NTenCentisecond->setNumDigits( 1 );
    NTenCentisecond->setMode( QLCDNumber::DEC );
    NTenCentisecond->setSegmentStyle( QLCDNumber::Filled );
    NTenCentisecond->setProperty( "intValue", 0 );

    NCentisecond = new QLCDNumber( this, "NCentisecond" );
    NCentisecond->setGeometry( QRect( 555, 5, 50, 121 ) ); 
    NCentisecond->setMinimumSize( QSize( 50, 110 ) );
    NCentisecond->setPalette( pal );
    NCentisecond->setCursor( QCursor( 0 ) );
    NCentisecond->setMouseTracking( FALSE );
    NCentisecond->setFocusPolicy( QLCDNumber::NoFocus );
    NCentisecond->setAcceptDrops( FALSE );
    NCentisecond->setAutoMask( FALSE );
    NCentisecond->setFrameShape( QLCDNumber::NoFrame );
    NCentisecond->setFrameShadow( QLCDNumber::Plain );
    NCentisecond->setLineWidth( 1 );
    NCentisecond->setMargin( 0 );
    NCentisecond->setMidLineWidth( 0 );
    NCentisecond->setSmallDecimalPoint( FALSE );
    NCentisecond->setNumDigits( 1 );
    NCentisecond->setMode( QLCDNumber::DEC );
    NCentisecond->setSegmentStyle( QLCDNumber::Filled );
    NCentisecond->setProperty( "intValue", 0 );

    MinutesLabel = new QLabel( this, "MinutesLabel" );
    MinutesLabel->setGeometry( QRect( 182, 127, 110, 20 ) ); 
    MinutesLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, MinutesLabel->sizePolicy().hasHeightForWidth() ) );
    MinutesLabel->setText( tr( "Minutes" ) );
    MinutesLabel->setAlignment( int( QLabel::AlignCenter ) );

    HoursLabel = new QLabel( this, "HoursLabel" );
    HoursLabel->setGeometry( QRect( 22, 127, 100, 20 ) ); 
    HoursLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, HoursLabel->sizePolicy().hasHeightForWidth() ) );
    HoursLabel->setText( tr( "Hours" ) );
    HoursLabel->setAlignment( int( QLabel::AlignCenter ) );

    DecisecondsLabel = new QLabel( this, "DecisecondsLabel" );
    DecisecondsLabel->setGeometry( QRect( 510, 130, 90, 18 ) ); 
    DecisecondsLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, DecisecondsLabel->sizePolicy().hasHeightForWidth() ) );
    DecisecondsLabel->setText( tr( "Centiseconds" ) );
    DecisecondsLabel->setAlignment( int( QLabel::AlignCenter ) );

    SecondsLabel = new QLabel( this, "SecondsLabel" );
    SecondsLabel->setGeometry( QRect( 360, 130, 100, 20 ) ); 
    SecondsLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, SecondsLabel->sizePolicy().hasHeightForWidth() ) );
    SecondsLabel->setText( tr( "Seconds" ) );
    SecondsLabel->setAlignment( int( QLabel::AlignCenter ) );

    NTenMinute = new QLCDNumber( this, "NTenMinute" );
    NTenMinute->setGeometry( QRect( 175, 5, 65, 121 ) ); 
    NTenMinute->setMinimumSize( QSize( 65, 110 ) );
    NTenMinute->setPalette( pal );
    NTenMinute->setCursor( QCursor( 0 ) );
    NTenMinute->setMouseTracking( FALSE );
    NTenMinute->setFocusPolicy( QLCDNumber::NoFocus );
    NTenMinute->setAcceptDrops( FALSE );
    NTenMinute->setAutoMask( FALSE );
    NTenMinute->setFrameShape( QLCDNumber::NoFrame );
    NTenMinute->setFrameShadow( QLCDNumber::Plain );
    NTenMinute->setLineWidth( 2 );
    NTenMinute->setMargin( 0 );
    NTenMinute->setMidLineWidth( 0 );
    NTenMinute->setSmallDecimalPoint( FALSE );
    NTenMinute->setNumDigits( 1 );
    NTenMinute->setSegmentStyle( QLCDNumber::Filled );
    NTenMinute->setProperty( "intValue", 0 );

	TimeCount = 0;
}

/*  
 *  Destroys the object and frees any allocated resources
 */
ExternalTimer::~ExternalTimer()
{
    // no need to delete child widgets, Qt does it all for us
}

bool ExternalTimer::event( QEvent* ev )
{
    bool ret = QWidget::event( ev );
	if ( ev->type() == QEvent::Hide )
	{
     	emit Closed( 0 );
	}
    return ret;
}

void ExternalTimer::IncreaseHour()
{
 	if (NHour->intValue() < 99) {
 		NHour->display( NHour->intValue() + 1 );
 		TimeCount = TimeCount + 360000;
 	}
 	else {
 		TimeCount = TimeCount - 35640000;
 		NHour->display( 0 );  //number rolls around
 	}
}

void ExternalTimer::DecreaseHour()
{
 	if (NHour->intValue() > 0) {
 		NHour->display( NHour->intValue() -1 );
 		TimeCount = TimeCount - 360000;
 	}
 	else {
 		TimeCount = TimeCount + 35640000;
 		NHour->display( 99 );  //number rolls around
 	}
}





void ExternalTimer::IncreaseTenMinute()
{
 	if (NTenMinute->intValue() < 5) {
 		NTenMinute->display( NTenMinute->intValue() + 1 );
 		TimeCount = TimeCount + 60000;
 	}
 	else {
 		TimeCount = TimeCount - 300000;
 		NTenMinute->display( 0 );  //number rolls around
 	}
}

void ExternalTimer::DecreaseTenMinute()
{
 	if (NTenMinute->intValue() > 0) {
 		NTenMinute->display( NTenMinute->intValue() -1 );
 		TimeCount = TimeCount - 60000;
 	}
 	else {
 		TimeCount = TimeCount + 300000;
 		NTenMinute->display( 5 );  //number rolls around
 	}
}






void ExternalTimer::IncreaseMinute()
{
 	if (NMinute->intValue() < 9) {
 		NMinute->display( NMinute->intValue() + 1 );
 		TimeCount = TimeCount + 6000;
 	}
 	else {
 		TimeCount = TimeCount - 54000;
 		NMinute->display( 0 );  //number rolls around
 	}
}

void ExternalTimer::DecreaseMinute()
{
 	if (NMinute->intValue() > 0) {
 		NMinute->display( NMinute->intValue() -1 );
 		TimeCount = TimeCount - 6000;
 	}
 	else {
 		TimeCount = TimeCount + 54000;
 		NMinute->display( 9 );  //number rolls around
 	}
}





void ExternalTimer::IncreaseTenSecond()
{
 	if (NTenSecond->intValue() < 5) {
 		NTenSecond->display( NTenSecond->intValue() + 1 );
 		TimeCount = TimeCount + 1000;
 	}
 	else {
 		TimeCount = TimeCount - 5000;
 		NTenSecond->display( 0 );  //number rolls around
 	}
}

void ExternalTimer::DecreaseTenSecond()
{
 	if (NTenSecond->intValue() > 0) {
 		NTenSecond->display( NTenSecond->intValue() -1 );
 		TimeCount = TimeCount - 1000;
 	}
 	else {
 		TimeCount = TimeCount + 5000;
 		NTenSecond->display( 5 );  //number rolls around
 	}
}




void ExternalTimer::IncreaseSecond()
{
 	if (NSecond->intValue() < 9) {
 		NSecond->display( NSecond->intValue() + 1 );
 		TimeCount = TimeCount + 100;
 	}
 	else {
 		TimeCount = TimeCount - 900;
 		NSecond->display( 0 );  //number rolls around
 	}
}

void ExternalTimer::DecreaseSecond()
{
 	if (NSecond->intValue() > 0) {
 		NSecond->display( NSecond->intValue() -1 );
 		TimeCount = TimeCount - 100;
 	}
 	else {
 		TimeCount = TimeCount + 900;
 		NSecond->display( 9 );  //number rolls around
 	}
}





void ExternalTimer::IncreaseTenCentisecond()
{
 	if (NTenCentisecond->intValue() < 9) {
 		NTenCentisecond->display( NTenCentisecond->intValue() + 1 );
 		TimeCount = TimeCount + 10;
 	}
 	else {
 		TimeCount = TimeCount - 90;
 		NTenCentisecond->display( 0 );  //number rolls around
 	}
}

void ExternalTimer::DecreaseTenCentisecond()
{
 	if (NTenCentisecond->intValue() > 0) {
 		NTenCentisecond->display( NTenCentisecond->intValue() -1 );
 		TimeCount = TimeCount - 10;
 	}
 	else {
 		TimeCount = TimeCount + 90;
 		NTenCentisecond->display( 9 );  //number rolls around
 	}
}




void ExternalTimer::IncreaseCentisecond()
{
 	if (NCentisecond->intValue() < 9) {
 		NCentisecond->display( NCentisecond->intValue() + 1 );
 		TimeCount = TimeCount + 1;
 	}
 	else {
 		TimeCount = TimeCount - 9;
 		NCentisecond->display( 0 );  //number rolls around
 	}
}

void ExternalTimer::DecreaseCentisecond()
{
 	if (NCentisecond->intValue() > 0) {
 		NCentisecond->display( NCentisecond->intValue() -1 );
 		TimeCount = TimeCount - 1;
 	}
 	else {
 		TimeCount = TimeCount + 9;
 		NCentisecond->display( 9 );  //number rolls around
 	}
}

void ExternalTimer::UpdateCounter()
{
 	ExternalTimer::TimeCount++;			
					
 	if (ExternalTimer::NCentisecond->intValue() < 9) {
 		ExternalTimer::NCentisecond->display(ExternalTimer::NCentisecond->intValue() + 1);
 	}
 	else {
 		ExternalTimer::NCentisecond->display(0);
 		if (ExternalTimer::NTenCentisecond->intValue() < 9) {
 			ExternalTimer::NTenCentisecond->display(ExternalTimer::NTenCentisecond->intValue() + 1);
 		}
 		else {
 			ExternalTimer::NTenCentisecond->display(0);
 			if (ExternalTimer::NSecond->intValue() < 9) {
 				ExternalTimer::NSecond->display(ExternalTimer::NSecond->intValue() + 1);
 			}
 			else {
 				ExternalTimer::NSecond->display(0);
 				if (ExternalTimer::NTenSecond->intValue() < 5) {
 					ExternalTimer::NTenSecond->display(ExternalTimer::NTenSecond->intValue() + 1);
 				}
 				else {
 					ExternalTimer::NTenSecond->display(0);
 					if (ExternalTimer::NMinute->intValue() < 9) {
 						ExternalTimer::NMinute->display(ExternalTimer::NMinute->intValue() + 1);
 					}
 					else {
 						ExternalTimer::NMinute->display(0);
 						if (ExternalTimer::NTenMinute->intValue() < 5) {
 							ExternalTimer::NTenMinute->display(ExternalTimer::NTenMinute->intValue() + 1);
 						}
 						else {
 							ExternalTimer::NTenMinute->display(0);
 							if (ExternalTimer::NHour->intValue() < 99) {
 								ExternalTimer::NHour->display(ExternalTimer::NHour->intValue() + 1);
 							}
 							else {
 								ExternalTimer::NHour->display(0);
 								ExternalTimer::TimeCount = 0;
 							}
 						}
 					}
 				}
 			}
 		}
 	}
}

void ExternalTimer::ResetCounter()
{
	NCentisecond->setProperty( "intValue", 0 );
	NTenCentisecond->setProperty( "intValue", 0 );
	NSecond->setProperty( "intValue", 0 );
	NTenSecond->setProperty( "intValue", 0 );
	NMinute->setProperty( "intValue", 0 );
	NTenMinute->setProperty( "intValue", 0 );
	NHour->setProperty( "intValue", 0 );
	
	TimeCount = 0;
}

void ExternalTimer::SetTimeCount( long t )
{
 	TimeCount = t;
	AdjustTimer();
}

void ExternalTimer::AdjustTimer()
{
	int test, subtract;
	test = int ( TimeCount );
	if ( test > 359999 ) {
		subtract = test/360000;
		NHour->display ( subtract );
		test = ( test - (subtract * 360000) );
	}
	else {
		NHour->display ( 0 );
	}
	if ( test > 59999 ) {
		subtract = test/60000;
		NTenMinute->display ( subtract );
		test = ( test - (subtract * 60000) );
	}
	else {
		NTenMinute->display ( 0 );
	}
	if ( test > 5999 ) {
		subtract = test/6000;
		NMinute->display ( subtract );
		test = ( test - (subtract * 6000) );
	}
	else {
		NMinute->display ( 0 );
	}
	if ( test > 999 ) {
		subtract = test/1000;
		NTenSecond->display ( test/1000 );
		test = ( test - (subtract * 1000) );
	}
	else {
		NTenSecond->display ( 0 );
	}
	if ( test > 99 ) {
		subtract = test/100;
		NSecond->display ( subtract );
		test = ( test - (subtract * 100) );
	}
	else {
		NSecond->display ( 0 );
	}
	if ( test > 9 ) {
		subtract = test/10;
		NTenCentisecond->display ( subtract );
		test = ( test - (subtract * 10 ) );
	}
	else {
		NTenCentisecond->display( 0 );
	}
	NCentisecond->display ( test );
}

void ExternalTimer::ChangeName( QString s )
{
	setCaption( s );
}

long ExternalTimer::GetTimeCount()
{
 	return TimeCount;
}

void ExternalTimer::keyPressEvent ( QKeyEvent *k )
{
    emit KeyPress( k );
}

void ExternalTimer::keyReleaseEvent ( QKeyEvent *k )
{
    emit KeyRelease( k );
}
