/***************************************************************************
                          qtabledisplay.cpp  -  description
                             -------------------
    begin                : Fri Sep 13 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "qtabledisplay.h"
#include "colortableitem.h"

QTableDisplay::QTableDisplay ( QWidget * parent, const char * name )
 	: QTable ( parent, name )
{
}

QTableDisplay::~QTableDisplay()
{
}

QWidget* QTableDisplay::beginEdit ( int row, int col, bool replace )
{
 	QTable::endEdit(row, col, FALSE, FALSE);
	return 0;
}

void QTableDisplay::Unselect()
{
	setCurrentCell( -1, -1 );
}

void QTableDisplay::columnClicked ( int col )
{
	if ( col >= 0 )
	{
		clearSelection();
		Unselect();
		emit Unselected();
	}
}

void QTableDisplay::PostText( int col, int row, QColor c, QString s )
{
    ColorTableItem *cti;
    cti = new ColorTableItem( this, QTableItem::Never, c, s );
    setItem( col, row, cti );
}

void QTableDisplay::PurgeTable()
{
    int row, col;

    for ( col = 0; col < numCols(); col++ )
    {
        for ( row = 0; row < numRows(); row++ )
        {
            if ( text( row, col ) != "" )
            {
                delete (ColorTableItem *)item( row, col );
            }
        }
    }
}
