/***************************************************************************
                          rtmixevents.cpp  -  description
                             -------------------
    begin                : Mon Dec 3 2001
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RTMIXEVENTS_H
#define RTMIXEVENTS_H

#include "warning.h"
#include "qradiobutton.h"

void RTMix::Error( QString s )
{
    //qDebug("start: %i", PlaybackStatus );
    T->Post( s, Verbose, PlaybackStatus, CompileFlag, RTEventButton->isOn(), MIDILogButton->isOn(), TimeCount, A->GetTimeCount() );
    /*
    if ( Verbose && PlaybackStatus > 0 || Verbose && RTEventButton->isOn() || s.lower().find("midi",0) != -1 && MIDILogButton->isOn() ||
        s.lower().find("error",0) != -1 || s.find(":|",0) == 0 || PlaybackStatus == 0 && !RTEventButton->isOn() )
    {
        if ( s.lower().find("error", 0) != -1 && s.lower().find("errors", 0 ) == -1 && s.lower().find("file ",0) == -1 ) //show-stoppers
        {
            T->ToggleAErrors( TRUE );
            s.insert( 0, "<font color=\"#ff0000\">" );
            s.append( "</font>" );
            if ( CompileFlag == TRUE && s.lower().find("osc ", 0 ) == -1 )
            {
                CompileFlag = FALSE;
            }
            if ( s.lower().find("midi",0) != -1 && s.lower().find("file ",0) == -1 )
            {
                S->MidiStatus->setText("Status: OFF");
                if ( MIDIEventButton->isOn() )
                {
                    MIDIEventButton->setOn( FALSE );
                }
            }
        }
        else if ( s.lower().find("warning:", 0) != -1 && s.lower().find("file ",0) == -1 ) //warnings
        {
            T->ToggleAWarns( TRUE );
            s.insert( 0, "<font color=\"#ffa000\">" );
            s.append( "</font>" );
        }
        else if ( s.lower().find("midi", 0) != -1 && s.lower().find("file ",0) == -1 ) //Midi issues
        {
            s.insert( 0, "<font color=\"#e8bfff\">" );
            s.append( "</font>" );
        }
        else if ( CompileFlag == TRUE ) //when compiling
        {
            s.insert( 0, "<font color=\"#ffff00\">" );
            s.append( "</font>" );
        }
        else if ( s.lower().find("--", 0) != -1 && s.lower().find("file ",0) == -1 ) //real-time stuff
        {
            //ErrorLog->setColor( QColor( 85, 255, 0 ) );
            //T->MultiLineEdit->setColor( QColor( 85, 255, 0 ) );
            s.insert( 0, "<font color=\"#55ff00\">" );
            s.append( "</font>" );
        }
        else if ( s.lower().find(":|", 0) != -1 && s.lower().find("file ",0) == -1 ) //Transport control log
        {
            s.insert( 0, "<font color=\"#82c8ff\"><b>" );
            s.append( "</font></b>" );
        }
        
    //ErrorLog->append( s );
    //ErrorLog->scrollToBottom();

        T->AddText( s );
    }
    //qDebug( "Flag: %d", CompileFlag );
    */
}

void RTMix::setPlaybackStatus( int s )
{
    PlaybackStatus = s;
    if ( s == 0 && !RTEventButton->isOn() || s > 0 )
    {
        T->ToggleAPlay( s );
    }
}

void RTMix::EmitMetroError( QString s )
{
    Error(  " -- Error occurred while trying to parse the new meter for the '" + s + "' metronome. Ignoring current change of meter.\n" );
}

void RTMix::AnnounceRT( bool check )
{
    if (check)
    {
        if ( Editor->text() != compareCompile ) {
            //Tabs->setCurrentPage ( 1 );
            Error ( "Need to compile event file first!\n" );
            Compile();
            RTEventButton->setOn( FALSE );
        }
        else
        {
            Error( " ++ Starting real-time event monitoring and disabling editor.\n" );
            QToolTip::add(  Editor, tr( "Event file edit window (currently disabled due to real-time events being enabled)" ) );
            Editor->setFocusPolicy( QWidget::NoFocus );
            Editor->setEnabled( FALSE );
            MIDIEventButton->setEnabled( TRUE );
            DisableEdit();
            T->ToggleAPlay( 4 );
        }
    }
    else
    {
        Error( " ++ Stopping real-time event monitoring and enabling editor.\n" );
        QToolTip::add(  Editor, tr( "Event file edit window" ) );
        Editor->setFocusPolicy( QWidget::ClickFocus );
        Editor->setEnabled( TRUE );
        MIDIEventButton->setOn( FALSE );
        MIDIEventButton->setEnabled( FALSE );
        MIDILogButton->setOn( FALSE );
        MIDILogButton->setEnabled( FALSE );
        AllowEdit();
        if ( PlaybackStatus == 0 )
        {
            T->ToggleAPlay( 0 );
        }
    }
}

void RTMix::AnnounceMIDI( bool check )
{
    if ( check )
    {
        MIDILogButton->setEnabled( TRUE );
    }
    else
    {
        MIDILogButton->setOn( FALSE );
        MIDILogButton->setEnabled( FALSE );
    }
}

void RTMix::UpdateEditorLine( int para, int pos )
{
    QString s;
    EditorLineNumber->setText( s.setNum( (para + 1), 10 ) );
}

void RTMix::GoToError()
{
    if ( ErrorCompile )
    {
        Editor->setCursorPosition( line - 1, 0 );
        Editor->setFocus();
    }
    else
    {
        Error ( "No compile-time errors found.\n" );
    }
}

/*
QString RTMix::ParseTime()
{
	long temp;
	QString value, digits;

	temp = TimeCount;
	value = "r:";
	value = value + digits.setNum( (temp/360000), 10 );
	temp = temp - ((temp/360000) * 360000);
	value = value + ":" + digits.setNum( (temp/6000), 10 );
	temp = temp - ((temp/6000) * 6000 );
	value = value + ":" + digits.setNum ( (temp/100), 10 );
	temp = temp - ((temp/100) * 100 );
	if ( temp < 10 )
	{
		value = value + ".0" + digits.setNum( temp, 10 );
	}
	else
	{
		value = value + "." + digits.setNum( temp, 10 );
	}

	temp = A->GetTimeCount();
	value = value + " a:";
	value = value + digits.setNum( (temp/360000), 10 );
	temp = temp - ((temp/360000) * 360000);
	value = value + ":" + digits.setNum( (temp/6000), 10 );
	temp = temp - ((temp/6000) * 6000 );
	value = value + ":" + digits.setNum ( (temp/100), 10 );
	temp = temp - ((temp/100) * 100 );
	if ( temp < 10 )
	{
		value = value + ".0" + digits.setNum( temp, 10 );
	}
	else
	{
		value = value + "." + digits.setNum( temp, 10 );
	}

	return value;
}
*/

void RTMix::AllowEdit()
{
	Edit = true;
    NCentisecond->setCursor( QCursor( 5 ) );
    NTenCentisecond->setCursor( QCursor( 5 ) );
    NSecond->setCursor( QCursor( 5 ) );
    NTenSecond->setCursor( QCursor( 5 ) );
    NMinute->setCursor( QCursor( 5 ) );
    NTenMinute->setCursor( QCursor( 5 ) );
    NHour->setCursor( QCursor( 5 ) );
    Metro1->SetResizable( TRUE );
    Metro2->SetResizable( TRUE );
    Metro3->SetResizable( TRUE );
    Metro4->SetResizable( TRUE );
    Window1->SetResizable( TRUE );
    Window2->SetResizable( TRUE );
    Window3->SetResizable( TRUE );
    Window4->SetResizable( TRUE );
    LEDw->SetResizable( TRUE );
}

void RTMix::DisableEdit()
{
	Edit = false;
    NCentisecond->setCursor( QCursor( 0 ) );
    NTenCentisecond->setCursor( QCursor( 0 ) );
    NSecond->setCursor( QCursor( 0 ) );
    NTenSecond->setCursor( QCursor( 0 ) );
    NMinute->setCursor( QCursor( 0 ) );
    NTenMinute->setCursor( QCursor( 0 ) );
    NHour->setCursor( QCursor( 0 ) );
    Metro1->SetResizable( FALSE );
    Metro2->SetResizable( FALSE );
    Metro3->SetResizable( FALSE );
    Metro4->SetResizable( FALSE );
    Window1->SetResizable( FALSE );
    Window2->SetResizable( FALSE );
    Window3->SetResizable( FALSE );
    Window4->SetResizable( FALSE );
    LEDw->SetResizable( FALSE );
}




void RTMix::IncreaseHour()
{
	ClearWarning();
	if (Edit) {
		if (NHour->intValue() < 99) {
			NHour->display( NHour->intValue() + 1 );
			TimeCount = TimeCount + 360000;
		}
		else {
			TimeCount = TimeCount - 35640000;
			NHour->display( 0 );  //number rolls around
		}
		E->IncreaseHour();
	}
}

void RTMix::DecreaseHour()
{
	ClearWarning();
	if (Edit) {
		if (NHour->intValue() > 0) {
			NHour->display( NHour->intValue() -1 );
			TimeCount = TimeCount - 360000;
		}
		else {
			TimeCount = TimeCount + 35640000;
			NHour->display( 99 );  //number rolls around
		}
		E->DecreaseHour();
	}
}





void RTMix::IncreaseTenMinute()
{
	ClearWarning();
	if (Edit) {
		if (NTenMinute->intValue() < 5) {
			NTenMinute->display( NTenMinute->intValue() + 1 );
			TimeCount = TimeCount + 60000;
		}
		else {
			TimeCount = TimeCount - 300000;
			NTenMinute->display( 0 );  //number rolls around
		}
		E->IncreaseTenMinute();
	}
}

void RTMix::DecreaseTenMinute()
{
	ClearWarning();
	if (Edit) {
		if (NTenMinute->intValue() > 0) {
			NTenMinute->display( NTenMinute->intValue() -1 );
			TimeCount = TimeCount - 60000;
		}
		else {
			TimeCount = TimeCount + 300000;
			NTenMinute->display( 5 );  //number rolls around
		}
		E->DecreaseTenMinute();
	}
}






void RTMix::IncreaseMinute()
{
	ClearWarning();
	if (Edit) {
		if (NMinute->intValue() < 9) {
			NMinute->display( NMinute->intValue() + 1 );
			TimeCount = TimeCount + 6000;
		}
		else {
			TimeCount = TimeCount - 54000;
			NMinute->display( 0 );  //number rolls around
		}
		E->IncreaseMinute();
	}
}

void RTMix::DecreaseMinute()
{
	ClearWarning();
	if (Edit) {
		if (NMinute->intValue() > 0) {
			NMinute->display( NMinute->intValue() -1 );
			TimeCount = TimeCount - 6000;
		}
		else {
			TimeCount = TimeCount + 54000;
			NMinute->display( 9 );  //number rolls around
		}
		E->DecreaseMinute();
	}
}





void RTMix::IncreaseTenSecond()
{
	ClearWarning();
	if (Edit) {
		if (NTenSecond->intValue() < 5) {
			NTenSecond->display( NTenSecond->intValue() + 1 );
			TimeCount = TimeCount + 1000;
		}
		else {
			TimeCount = TimeCount - 5000;
			NTenSecond->display( 0 );  //number rolls around
		}
		E->IncreaseTenSecond();
	}
}

void RTMix::DecreaseTenSecond()
{
	ClearWarning();
	if (Edit) {
		if (NTenSecond->intValue() > 0) {
			NTenSecond->display( NTenSecond->intValue() -1 );
			TimeCount = TimeCount - 1000;
		}
		else {
			TimeCount = TimeCount + 5000;
			NTenSecond->display( 5 );  //number rolls around
		}
		E->DecreaseTenSecond();
	}
}




void RTMix::IncreaseSecond()
{
	ClearWarning();
	if (Edit) {
		if (NSecond->intValue() < 9) {
			NSecond->display( NSecond->intValue() + 1 );
			TimeCount = TimeCount + 100;
		}
		else {
			TimeCount = TimeCount - 900;
			NSecond->display( 0 );  //number rolls around
		}
		E->IncreaseSecond();
	}
}

void RTMix::DecreaseSecond()
{
	ClearWarning();
	if (Edit) {
		if (NSecond->intValue() > 0) {
			NSecond->display( NSecond->intValue() -1 );
			TimeCount = TimeCount - 100;
		}
		else {
			TimeCount = TimeCount + 900;
			NSecond->display( 9 );  //number rolls around
		}
		E->DecreaseSecond();
	}
}





void RTMix::IncreaseTenCentisecond()
{
	ClearWarning();
	if (Edit) {
		if (NTenCentisecond->intValue() < 9) {
			NTenCentisecond->display( NTenCentisecond->intValue() + 1 );
			TimeCount = TimeCount + 10;
		}
		else {
			TimeCount = TimeCount - 90;
			NTenCentisecond->display( 0 );  //number rolls around
		}
		E->IncreaseTenCentisecond();
	}
}

void RTMix::DecreaseTenCentisecond()
{
	ClearWarning();
	if (Edit) {
		if (NTenCentisecond->intValue() > 0) {
			NTenCentisecond->display( NTenCentisecond->intValue() -1 );
			TimeCount = TimeCount - 10;
		}
		else {
			TimeCount = TimeCount + 90;
			NTenCentisecond->display( 9 );  //number rolls around
		}
		E->DecreaseTenCentisecond();
	}
}




void RTMix::IncreaseCentisecond()
{
	ClearWarning();
	if (Edit) {
		if (NCentisecond->intValue() < 9) {
			NCentisecond->display( NCentisecond->intValue() + 1 );
			TimeCount = TimeCount + 1;
		}
		else {
			TimeCount = TimeCount - 9;
			NCentisecond->display( 0 );  //number rolls around
		}
		E->IncreaseCentisecond();
	}
}

void RTMix::DecreaseCentisecond()
{
	ClearWarning();
	if (Edit) {
		if (NCentisecond->intValue() > 0) {
			NCentisecond->display( NCentisecond->intValue() -1 );
			TimeCount = TimeCount - 1;
		}
		else {
			TimeCount = TimeCount + 9;
			NCentisecond->display( 9 );  //number rolls around
		}
		E->DecreaseCentisecond();
	}
}

void RTMix::UpdateWarnDisplay()
{
		if (RTMix::NWarnCentisecond->intValue() > 0) {
			RTMix::NWarnCentisecond->display(RTMix::NWarnCentisecond->intValue() - 1);
		}
		else {
			RTMix::NWarnCentisecond->display(9);
			if (RTMix::NWarnTenCentisecond->intValue() > 0) {
				RTMix::NWarnTenCentisecond->display(RTMix::NWarnTenCentisecond->intValue() - 1);
			}
			else {
				RTMix::NWarnTenCentisecond->display(9);
				if (RTMix::NWarnSecond->intValue() > 0) {
					RTMix::NWarnSecond->display(RTMix::NWarnSecond->intValue() - 1);
				}
				else {
					RTMix::NWarnSecond->display(9);
					if (RTMix::NWarnTenSecond->intValue() > 0) {
						RTMix::NWarnTenSecond->display(RTMix::NWarnTenSecond->intValue() - 1);
					}
					else {
						RTMix::NWarnTenSecond->display(5);
						if (RTMix::NWarnMinute->intValue() > 0) {
							RTMix::NWarnMinute->display(RTMix::NWarnMinute->intValue() - 1);
						}
						else {
							RTMix::NWarnMinute->display(9);
							if (RTMix::NWarnTenMinute->intValue() > 0) {
								RTMix::NWarnTenMinute->display(RTMix::NWarnTenMinute->intValue() - 1);
							}	
						}
					}
				}
			}
		}
}


void RTMix::AdjustRTLastTimes()
{
    for (int n = 0; n < MAXRTEVENTS; n++)
    {
        if ( RTEvents[n] != NULL )
        {
            RTEvents[n]->lastTime = -5;
        }
    }
}

void RTMix::Stop( QString net )
{
    //AdjustRTLastTimes();
    if ( PlaybackStatus > 0 )
    {
        if ( net == NULL )
        {
            QString time;
            time.setNum( A->GetTimeCount(), 10 );
            SendGlobal( "C:0-" + time + "\n" );
        }
        else
        {
            SendGlobal( net );
        }
        OldPlaybackStatus = 0;
        ResetPlayer();
        AllowEdit();
        Error( ":|STOP|:" );
    }
    else if ( PlaybackStatus < 3 ) {  //if the stop is double-pressed then reset the counters
        if ( TimeCount != 0 || Move != Start || A->GetTimeCount() != 0 )
        {
            if ( net == NULL )
            {
                QString time;
                time.setNum( A->GetTimeCount(), 10 );
                SendGlobal( "C:1-" + time + "\n" );
            }
            else
            {
                SendGlobal( net );
            }
            Error( ":|RESET|:" );
            AdjustRTLastTimes();
            TextInterface->setText("");
            NCentisecond->setProperty( "intValue", 0 );
            NTenCentisecond->setProperty( "intValue", 0 );
            NSecond->setProperty( "intValue", 0 );
            NTenSecond->setProperty( "intValue", 0 );
            NMinute->setProperty( "intValue", 0 );
            NTenMinute->setProperty( "intValue", 0 );
            NHour->setProperty( "intValue", 0 );
            E->ResetCounter();
            A->ResetCounter();
            FollowMove = NULL;
            MIDIEventButton->setOn( FALSE );
            RTEventButton->setOn( FALSE );
            //LastSent = "";
            //LastSentTime = -1;

            ResetOtherTimers();
            ClearWarning();

            //KILLING ALL EVENTS
            Curr = Start;
            while ( Curr->time <= TimeCount && Curr->next != NULL ) {
                if ( Curr != Start && Curr->killEvent != "none" ) {
                    if ( Curr->netAddress > -2 )
                    {
                        SendSingle("P:" + Curr->killEvent + "\n", Curr->netAddress );
                    }
                    else system ( "killall " + Curr->killEvent );
                }
                Curr = Curr->next;
            }
            if ( Curr != Start && Curr->killEvent != "none" ) {
                if ( Curr->netAddress > -2 )
                {
                    SendSingle("P:" + Curr->killEvent + "\n", Curr->netAddress );
                }
                else system ( "killall " + Curr->killEvent );
            }
            TimeCount = 0;

            //RT EVENTS
            for ( int n = 0; n < MAXRTEVENTS; n++ )
            {
                if ( RTEvents[n] != NULL )
                {
                    if ( RTEvents[n]->killEvent != "none" )
                    {
                        if ( RTEvents[n]->netAddress > -2 )
                        {
                            SendSingle("P:" + RTEvents[n]->killEvent + "\n", RTEvents[n]->netAddress );
                        }
                    else system ( "killall " + RTEvents[n]->killEvent );
                    }
                }
            }

            if ( netEvents != "" )
            {
                system ( netEvents );
                netEvents = "";
            }

            ResetCue();
            Move = Start;
            while ( Move != End && Move->absat == 0 )
            {
                Move = Move->next;
            }
            if ( Move != End && Move->absat == 1 || Move == End && Move->absat == 1 )
            {
                AbsMove = Move;
                //qDebug(AbsMove->text + " AbsEvent %i", AbsMove->time ); //DEBUG
            }
            else
            {
                AbsMove = NULL;
            }

            Move = Start;
        }
	}
}

int RTMix::Play( QString net )
{
    if ( Editor->text() != compareCompile ) {
    	Tabs->setCurrentPage ( 1 );
		Error ( "Need to compile event file first!\n" );
		Compile();
		PlayButton->setOn( false );
		return 0;
	}
    else
    {
        if ( net == NULL )
        {
            QString time;
            time.setNum( A->GetTimeCount(), 10 );
            SendGlobal( "C:4-" + time + "\n" );
        }
        else
        {
            SendGlobal( net );
        }
    }
	if ( Tabs->currentPage() != PlayTab ) {
		Tabs->setCurrentPage( 0 );
		//Error("BLAH");
	}			
	if (PlaybackStatus == 0 ) {
       Error(":|PLAY|:");
		PlayIndicator->setPixmap( imageRedon );
		DisableEdit();
		//DISABLE APPROPRIATE BUTTONS
		RewindButton->setPixmap( imageRewindOff );
		RewindButton->setAccel( CTRL + Key_Left );
    	FForwardButton->setPixmap( imageFForwardOff );
		FForwardButton->setAccel( CTRL + Key_Right );
		CompileButton->setDisabled(true);

		if ( OldPlaybackStatus != 0 ) {
			setPlaybackStatus( OldPlaybackStatus );
			OldPlaybackStatus = 0;
		}
		else {
			setPlaybackStatus( 4 );
		}
		//CHECK TIMER AND LOOK FOR THE APPROPRIATE PLACE IN THE CUE
		Move = Start;
		while ( Move->time < TimeCount && Move->next != NULL ) {
			Move = Move->next;
		}
		//PlayCue = Move;
	}
	else {	
		PlayButton->setOn( true );
	}
	return 0;
}

void RTMix::Pause( QString net )
{
    if ( net == NULL )
    {
        QString time;
        time.setNum( A->GetTimeCount(), 10 );
        SendGlobal( "C:3-" + time + "\n" );
    }
    else
    {
        SendGlobal( net );
    }
	if (PlaybackStatus < 3) {  //if performance is stopped, disable pause button
		PauseButton->setOn( false );
	}
	if (PlaybackStatus >= 4) {
		OldPlaybackStatus = PlaybackStatus;
		AllowEdit();
		setPlaybackStatus( 3 );
       Error( ":|PAUSE|:");
		PlayIndicator->setPixmap( imageRedoff );
		PauseCounter = 0;
	}
	else if (PlaybackStatus == 3) {
		//CHECK TIMER AND LOOK FOR THE APPROPRIATE PLACE IN THE CUE
       Error( ":|RESUME|:");
		if ( TimeCount == 0 ) {
			Move = Start;
			while ( Move->time <= TimeCount && Move->next != NULL ) {
				Move = Move->next;
			}
		}
		if (OldPlaybackStatus > 0) {
			setPlaybackStatus( OldPlaybackStatus );
			QString tmp;
			tmp.setNum( OldPlaybackStatus, 10 );
		}
		else {
			setPlaybackStatus( 4 );
		}
		OldPlaybackStatus = 0;
		DisableEdit();
    	PlayIndicator->setPixmap( imageRedon );

	}
}

void RTMix::Panic( QString net )
{
	Curr = Start;
	while ( Curr->time <= TimeCount && Curr->next != NULL ) {
		if ( Curr != Start && Curr->killEvent != "none" ) {
          //check if this is a networked event
          if ( Curr->netAddress > -2 )
          {
              SendSingle("P:" + Curr->killEvent + "\n", Curr->netAddress );
          }
          else system ( "killall " + Curr->killEvent );
		}
		Curr = Curr->next;
	}
	if ( Curr != Start && Curr->killEvent != "none" ) {
      if ( Curr->netAddress > -2 )
      {
          SendSingle("P:" + Curr->killEvent + "\n", Curr->netAddress );
      }
      else system ( "killall " + Curr->killEvent );
	}
	for ( int n = 0; n < MAXRTEVENTS; n++ )
	{
      if ( RTEvents[n] != NULL && RTEvents[n]->killEvent != "none" )
		{
          if ( RTEvents[n]->netAddress > -2 )
          {
              SendSingle("P:" + RTEvents[n]->killEvent + "\n", RTEvents[n]->netAddress );
          }
          else system ( "killall" + RTEvents[n]->killEvent );
		}
	}
    if ( netEvents != "" )
    {
        system ( netEvents );
        netEvents = "";
    }
	if (PlaybackStatus > 0 ) {

        Error( ":|PANIC|:" );
        ResetPlayer();
        if ( net == NULL )
        {
            QString time;
            time.setNum( A->GetTimeCount(), 10 );
            SendGlobal("C:0-" + time + "\n");
        }
        else
        {
            SendGlobal( net );
        }
	}
}

void RTMix::AdjustTimer( QString net )
{
	QString s;

	int test, subtract;

    test = int (TimeCount);
	if ( test > 359999 ) {
		subtract = test/360000;
		NHour->display ( subtract );
		//Debug.setNum( test, 10 );
		//TextInterface->insert( Debug + " " );
		test = ( test - (subtract * 360000) );
	}
	else {
		NHour->display ( 0 );
	}
	if ( test > 59999 ) {
		subtract = test/60000;
		NTenMinute->display ( subtract );
		//Debug.setNum( test, 10 );
		//TextInterface->insert( Debug + " " );
		test = ( test - (subtract * 60000) );
	}
	else {
		NTenMinute->display ( 0 );
	}
	if ( test > 5999 ) {
		subtract = test/6000;
		NMinute->display ( subtract );
		//Debug.setNum( test, 10 );
		//TextInterface->insert( Debug + " " );
		test = ( test - (subtract * 6000) );
	}
	else {
		NMinute->display ( 0 );
	}
	if ( test > 999 ) {
		subtract = test/1000;
		NTenSecond->display ( test/1000 );
		//Debug.setNum( test, 10 );
		//TextInterface->insert( Debug + " " );
		test = ( test - (subtract * 1000) );
	}
	else {
		NTenSecond->display ( 0 );
	}
	if ( test > 99 ) {
		subtract = test/100;
		NSecond->display ( subtract );
		//Debug.setNum( test, 10 );
		//TextInterface->insert( Debug + " " );
		test = ( test - (subtract * 100) );
	}
	else {
		NSecond->display ( 0 );
	}
	if ( test > 9 ) {
		subtract = test/10;
		NTenCentisecond->display ( subtract );
		//Debug.setNum( test, 10 );
		//TextInterface->insert( Debug + " " );
		test = ( test - (subtract * 10 ) );
	}
	else {
		NTenCentisecond->display( 0 );
	}
	NCentisecond->display ( test );
	//Debug.setNum( test, 10 );
	//TextInterface->insert( Debug + " " );
	E->SetTimeCount( Move->time );
    //qDebug("New time: %i", TimeCount);
   s.setNum( TimeCount, 10 );
   SendGlobal( "J:" + s + "-" + s + "\n" );
   AdjustRTLastTimes();
}

void RTMix::ToggleSize( int State )
{
	//qDebug (" 0 " );
	if ( State > 0 && !CurrSize ) {
		//qDebug( " 1 ");
		setMinimumHeight( 378 );
		resize(0, -390);
		setMaximumHeight( 378 );
		//S->setWinSize( 1 );
		CurrSize = 1;
		SizeButton->setOn( TRUE );
	}
	else if ( State == 0 && CurrSize )
	{
		//qDebug(" 2 ");
		setMaximumHeight( 768 );
		resize(0, 390);
		setMinimumHeight( 768 );
		//S->setWinSize( 0 );
		CurrSize = false;
		SizeButton->setOn( FALSE );
	}
}

int RTMix::FF()
{
  //QString s;
  if ( PlaybackStatus == 0 ) {
		if ( Editor->text() != compareCompile ) {
	   	 	Tabs->setCurrentPage ( 1 );
			Error ( "Need to compile event file first!\n" );
			Compile();
			PlayButton->setOn( false );
			return 0;
		}
        Error( ":|FFW|:");

		Move = Start;
		while ( Move->time <= TimeCount && Move->next != NULL ) {
			Move = Move->next;
		}

		//if (Move != End) {
		//	Move = Move->next;
			//TextInterface->insert (">"); //DEBUG
		//}
		while ( Move->ID != 4 && Move->next != NULL ) { //Search for next checkpoint
			Move = Move->next;
			//TextInterface->insert (">"); //DEBUG
		}
		//TextInterface->insert ("FF "); //DEBUG
		if ( Move == End && Move->ID != 4 || TimeCount == Move->time ) {
			Error ( "No checkpoints to fast-forward to.\n" ) ;
			return 0;
		}

		Error ( "Reached checkpoint '" + Move->say +"'.\n" );
		ClearWarning();
		TimeCount = long(Move->time);
		AdjustTimer( NULL );
		E->SetTimeCount( TimeCount );
       FollowMove = NULL;
		//s.setNum( TimeCount, 10 );
		//SendGlobal( "J:" + s + "\n" );
		ResetCue();
	}
	return 0;
}

int RTMix::REW()
{

  //QString s;
	if (PlaybackStatus == 0 ) {
		if ( Editor->text() != compareCompile ) {
	    	Tabs->setCurrentPage ( 1 );
			Error ( "Need to compile event file first!\n" );
			Compile();
			PlayButton->setOn( false );
			return 0;
		}
        Error( ":|REW|:");
		ClearWarning();

		Move = Start;
		while ( Move->time < TimeCount && Move->next != NULL && Move->next->time < TimeCount ) {
          Move = Move->next;
		}

		//if (Move != Start) {
		//	Move = Move->prev;
			//TextInterface->insert ("<"); //DEBUG
		//}
		while ( Move->ID != 4 && Move->prev != NULL ) { //Search for previous checkpoint
			Move = Move->prev;
		}
        if ( Move == Start ) { Error( "Reached Start\n" ); }
		else { Error( "Reached checkpoint '" + Move->say +"'.\n" ); }
		TimeCount = long(Move->time);
		AdjustTimer( NULL );
		E->SetTimeCount( TimeCount );
      FollowMove = NULL;
      ResetCue();
      //s.setNum( TimeCount, 10 );
      //SendGlobal( "J:" + s + "\n" );
	}
	return 0;
}

void RTMix::ClearContinuousEvents(  bool b )
{
	if ( CountdownPtr != NULL )
	{
		if ( CountdownPtr->light > 0 )
		{
         	if ( CountdownPtr->light == 1 ) {
             	WarnExecute->setPixmap( imageGreenoff );
			}
         	if ( CountdownPtr->light == 2 ) {
   				WarnIndicator->setPixmap( imageYellowoff );
			}
         	if ( CountdownPtr->light == 3 ) {
   				WarnIndicator->setPixmap( imageYellowoff );
   				WarnExecute->setPixmap( imageGreenoff );
			}
         	if ( CountdownPtr->light == 4 ) {
             	Window1->ResetDisplay();
			}
         	if ( CountdownPtr->light == 5 ) {
             	Window2->ResetDisplay();
			}
         	if ( CountdownPtr->light == 6 ) {
             	Window3->ResetDisplay();
			}
         	if ( CountdownPtr->light == 7 ) {
             	Window4->ResetDisplay();
			}
         	if ( CountdownPtr->light > 7 ) {
             	LEDw->ResetDisplay();
			}
		}
		CountdownPtr = NULL;
		if ( b )
		{
     		if ( EventPtr != NULL && EventPtr->light > 0 ) { UpdateLights ( EventPtr, 0 );  EventPtr = NULL; }
     		if ( TextPtr != NULL && TextPtr->light > 0 ) { UpdateLights ( TextPtr, 0 );  TextPtr = NULL; }
     		if ( CheckpointPtr != NULL && CheckpointPtr->light > 0 ) { UpdateLights ( CheckpointPtr, 0 );  CheckpointPtr = NULL; }
     		if ( ClearPtr != NULL && ClearPtr->light > 0 ) { UpdateLights ( ClearPtr, 0 );  ClearPtr = NULL; }
     		if ( WarningPtr != NULL && WarningPtr->light > 0 ) { UpdateLights ( WarningPtr, 0 );  WarningPtr = NULL; }
     		if ( MetroPtr != NULL && MetroPtr->light > 0 ) { UpdateLights ( MetroPtr, 0 );  MetroPtr = NULL; }
     		if ( JumpPtr != NULL && JumpPtr->light > 0 ) { UpdateLights ( JumpPtr, 0 );  JumpPtr = NULL; }
     		if ( RandPtr != NULL && RandPtr->light > 0 ) { UpdateLights ( RandPtr, 0 );  RandPtr = NULL; }
     		if ( ChangePtr != NULL && ChangePtr->light > 0 ) { UpdateLights ( ChangePtr, 0 );  ChangePtr = NULL; }
     		if ( SeedPtr != NULL && SeedPtr->light > 0 ) { UpdateLights ( SeedPtr, 0 );  SeedPtr = NULL; }
     		if ( RewPtr != NULL && RewPtr->light > 0 ) { UpdateLights ( RewPtr, 0 );  RewPtr = NULL; }
     		if ( FfwPtr != NULL && FfwPtr->light > 0 ) { UpdateLights ( FfwPtr, 0 );  FfwPtr = NULL; }
     		if ( ToggleMetroPtr != NULL && ToggleMetroPtr->light > 0 ) {  UpdateLights( ToggleMetroPtr, 0 );  ToggleMetroPtr = NULL; }
     		if ( AssignPtr != NULL && AssignPtr->light > 0 ) { UpdateLights ( AssignPtr, 0 );  AssignPtr = NULL; }
     		if ( ToggleRTPtr != NULL && ToggleRTPtr->light > 0 ) { UpdateLights ( ToggleRTPtr, 0 );  ToggleRTPtr = NULL; }
     		if ( ToggleNetPtr != NULL && ToggleNetPtr->light > 0 ) { UpdateLights ( ToggleNetPtr, 0 );  ToggleNetPtr = NULL; }
     		if ( ToggleMIDIPtr != NULL && ToggleMIDIPtr->light > 0 ) { UpdateLights ( ToggleMIDIPtr, 0 );  ToggleMIDIPtr = NULL; }
          //PausePtr = NULL;
     		//StopPtr = NULL;
     		//SetNetPtr = NULL;
		}
	}	
}

void RTMix::ClearWarning()
{
	//if ( CountdownCount > 0 ) {
		CountdownCount = 0;
		WarningCount = 0;
		NWarnCentisecond->setProperty( "intValue", 0 );
		NWarnTenCentisecond->setProperty( "intValue", 0 );
		NWarnSecond->setProperty( "intValue", 0 );
		NWarnTenSecond->setProperty( "intValue", 0 );
		NWarnMinute->setProperty( "intValue", 0 );
		NWarnTenMinute->setProperty( "intValue", 0 );
   		WarnIndicator->setPixmap( imageYellowoff );
   		WarnExecute->setPixmap( imageGreenoff );

		EventPtr = NULL;
		CountdownPtr = NULL;
		TextPtr = NULL;
		CheckpointPtr = NULL;
		//PausePtr = NULL;
		//StopPtr = NULL;
		ClearPtr = NULL;
		WarningPtr = NULL;
		MetroPtr = NULL;
		JumpPtr = NULL;
		RandPtr = NULL;
		ChangePtr = NULL;
		SeedPtr = NULL;
		RewPtr = NULL;
		FfwPtr = NULL;
		ToggleMetroPtr = NULL;	
		AssignPtr = NULL;
		ToggleRTPtr = NULL;
		//SetNetPtr = NULL;
		ToggleNetPtr = NULL;
		ToggleMIDIPtr = NULL;
		
		ResetOtherTimers();
	//}
}

void RTMix::ResetOtherTimers()
{
	//RESET WARNING WINDOWS
 	Window1->ResetDisplay();
 	Window2->ResetDisplay();
 	Window3->ResetDisplay();
 	Window4->ResetDisplay();

	//RESET METROS
	Metro1->ResetMetro( 0 );
	Metro2->ResetMetro( 0 );
	Metro3->ResetMetro( 0 );
	Metro4->ResetMetro( 0 );

	//RESET LEDw
	LEDw->ResetDisplay();
}


void RTMix::ResetPlayer()
{
	PlayIndicator->setPixmap( imageRedoff );

	RewindButton->setPixmap( imageRewind );
	RewindButton->setAccel( QAccel::stringToKey( S->GetAccel(2) ) );
	FForwardButton->setPixmap( imageFForward );
	FForwardButton->setAccel( QAccel::stringToKey( S->GetAccel(3) ) );

	PlayButton->setOn( false );
	PauseButton->setOn( false );
	CompileButton->setDisabled(false);
	PlayButton->setOn( false );
	PauseButton->setOn( false );
	RewindButton->setOn( false );
	FForwardButton->setOn( false );

	setPlaybackStatus( 0 );
}

void RTMix::AdjustOtherTimers( struct eventCue *EventPointer )
{
 	if ( EventPointer->light == 4 )
	{
     	Window1->SetDisplay( EventPointer, EventPointer->countdown );
	}
 	if ( EventPointer->light == 5 )
	{
     	Window2->SetDisplay( EventPointer, EventPointer->countdown );
	}
 	if ( EventPointer->light == 6 )
	{
     	Window3->SetDisplay( EventPointer, EventPointer->countdown );
	}
 	if ( EventPointer->light == 7 )
	{
     	Window4->SetDisplay( EventPointer, EventPointer->countdown );
	}
}

void RTMix::ResetCue()
{
	Move = Start;
	Curr = Move;
	if ( Move != End )
	{
       	MoveCopy = StartCopy->next;
		Move = Move->next;
       	while ( Move != End )
       	{
			CopyCue ( MoveCopy, Move );
			Move = Move->next;
			MoveCopy = MoveCopy->next;
       	}
       	if ( Move == End && End != Start )
		{
			CopyCue ( MoveCopy, Move );
       	}
	}
	//RESET RTEVENTTABLE MODIFIED FLAG
	ResetRTTable( 0 );
}

void RTMix::CopyCue( struct eventCue *from, struct eventCue *to )
{
	struct eventCue *Next;
	struct eventCue *Prev;

	Next = to->next;
	Prev = to->prev;

	*to = *from;

	to->next = Next;
	to->prev = Prev;
}

void RTMix::ResetRTTable( bool b )
{
	int n, m, c, r;

	if ( !b )
	{
		n = 3;
		m = 4;
	}
	else
	{
		n = 0;
		m = 4;
       //Full purge resetting the OSC flag
       haveOSC = FALSE;
	}

    for ( r = 0; r < MAXVARS; r ++ )
	{
		RandomNum[r] = 0.0;

	 	for ( c = n; c < m; c++ )
		{
			//qDebug( "%i, %i" + RTEventTable->text( r, c ), r, c );
     		if ( RTEventTable->text( r, c) != "" )
			{
             	//RTEventTable->setText( r, c, "" );
				if ( n == 2 && c == 2 )
				{
					if ( RTEventsCopy[r] != NULL )
					{
						*RTEvents[r] = *RTEventsCopy[r];
					}
					else
					{
                     	RTEvents[r] = NULL;
					}
				}
				if ( n == 0 && c == 3 )
				{
                  delete RTEvents[r];
					RTEvents[r] = NULL;
					delete RTEventsCopy[r];
					RTEventsCopy[r] = NULL;
                  //CLEAR OUT OSC STUFF
				}
              if ( !b )
              {
                  RTEventTable->setText( r, c, " " );
              }
              else
              {
                  delete (ColorTableItem *) RTEventTable->item( r, c );
              }
			}
		}
	}
}

#endif
