/***************************************************************************
                          settings-lcds.h  -  description
                             -------------------
    begin                : Thu Aug 29 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qcolordialog.h>
#include <qcolor.h>

void settings::AdjustPreviewLCD( int n )
{
    cgLCD.setColor( QColorGroup::Foreground, Current->LEDColor[n] );
   	cgLCD.setColor( QColorGroup::Button, Current->LEDColor[n] );
	cgLCD.setColor( QColorGroup::Light, Current->LEDColor[n].light(150) );
   	cgLCD.setColor( QColorGroup::Midlight, Current->LEDColor[n].light(125) );
   	cgLCD.setColor( QColorGroup::Dark, Current->LEDColor[n].light(50)  );
   	cgLCD.setColor( QColorGroup::Mid, Current->LEDColor[n].light(66) );
	palLCD.setActive( cgLCD );
	palLCD.setInactive( cgLCD );
	palLCD.setDisabled( cgLCD );
	PreviewLCD->setPalette( palLCD );	
}

void settings::UpdatePreviewColor()
{
	int n;

	n = TimerComboBox->currentItem();

	QColor c = QColorDialog::getColor( Current->LEDColor[n], this, "Select New Color" );
	if ( c.isValid() )
	{
		Current->LEDColor[n] = c;
		AdjustPreviewLCD( n );
        ApplyButton->setEnabled( TRUE );
	}
}

void settings::DefaultColor()
{
	int n;

	n = TimerComboBox->currentItem();

	Current->LEDColor[n] = Default->LEDColor[n];
	AdjustPreviewLCD( n );
    ApplyButton->setEnabled( TRUE );
}
