/***************************************************************************
                          simpleserver.h  -  description
                             -------------------
    begin                : Sun Sep 15 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SIMPLESERVER_H
#define SIMPLESERVER_H

#include <qserversocket.h>
#include "eventcue.h"

class RTMix;

/**
  *@author Ivica Bukvic
  */

class ClientSocket;
class RTMix;

class SimpleServer : public QServerSocket
{
	Q_OBJECT
public:
	SimpleServer( RTMix *r, QObject* parent=0, Q_UINT16 prt=9900 );
	~SimpleServer();
	void newConnection( int );

	RTMix *ptr;
	struct eventCue *e;
	struct eventCue *EventPtr;
	struct eventCue *CountdownPtr;
	struct eventCue *TextPtr;
	struct eventCue *CheckpointPtr;
	struct eventCue *PausePtr;
	struct eventCue *StopPtr;
	struct eventCue *ClearPtr;
	struct eventCue *WarningPtr;
	struct eventCue *MetroPtr;
	struct eventCue *JumpPtr;
	struct eventCue *RandPtr;
	struct eventCue *ChangePtr;
	struct eventCue *SeedPtr;
	struct eventCue *RewPtr;
	struct eventCue *FfwPtr;
	struct eventCue *ToggleMetroPtr;
	struct eventCue *AssignPtr;
	struct eventCue *ToggleRTPtr;
	struct eventCue *SetNetPtr;
	struct eventCue *ToggleNetPtr;
	struct eventCue *ToggleMIDIPtr;
	struct eventCue *PlayPtr;

  ClientSocket *sock[256];
	int Status;
	int Port;
	int num; //current number of connections
	//QString transferred;

public slots:
	//void CloseAllConnections();
	void CloseConnection();
	//void EnableConnections();
	int Incoming( int, QString );

private slots:
    void CheckAuth( int );

signals:
    void newConnect( QString );
	void Read( QString );
	void Receiving( bool );
	void Sending( bool );
};

#endif
