/***************************************************************************
                          splash.cpp  -  description
                             -------------------
    begin                : Thu Sep 5 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qlabel.h>
#include <qprogressbar.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qapplication.h>
#include <qtimer.h>

#include <qdesktopwidget.h>
#include <qapplication.h>

#include "splash.h"
#include "path.h"
//#include "splash-image.h"
#include "version.h"

/* 
 *  Constructs a Splash which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
Splash::Splash( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    //QPixmap image0( ( const char** ) image0_data );
    if ( !name )
    setName( "Splash" );
    resize( 250, 330 ); 
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, sizePolicy().hasHeightForWidth() ) );
    setMinimumSize( QSize( 250, 330 ) );
    setMaximumSize( QSize( 250, 330 ) );
    setCaption( tr( "Splash" ) );
    SplashLayout = new QGridLayout( this ); 
    SplashLayout->setSpacing( 6 );
    SplashLayout->setMargin( 6 );

    QPixmap imageBckgd;
    imageBckgd.load(path + "/images/splash.xpm", NULL, DiffuseAlphaDither);
    setPaletteBackgroundPixmap( imageBckgd );

    //Label = new QFont( TitleLabel->font() );
    //Label->setPointSize( 9 );
    //Label->setBold( TRUE );
    //Progress = new QFont( ProgressBar->font() );
    //Progress->setPointSize( 8 );
    //Progress->setBold( FALSE );

    TitleLabel = new QLabel( this, "TitleLabel" );
    TitleLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)0, TitleLabel->sizePolicy().hasHeightForWidth() ) );
    QFont TitleLabel_font(  QApplication::font() );
    TitleLabel_font.setPointSize( 12 );
    TitleLabel_font.setBold( TRUE );
    TitleLabel->setFont( TitleLabel_font ); 
    TitleLabel->setText( tr( "RTMix v." + Version ) );
    TitleLabel->setAlignment( int( QLabel::AlignCenter ) );

    SplashLayout->addWidget( TitleLabel, 0, 0 );
/*
    SplashLogo = new QLabel( this, "SplashLogo" );
    SplashLogo->setMinimumSize( QSize( 240, 240 ) );
    SplashLogo->setMaximumSize( QSize( 240, 240 ) );
    SplashLogo->setFrameShape( QLabel::WinPanel );
    SplashLogo->setFrameShadow( QLabel::Sunken );
    SplashLogo->setLineWidth( 0 );
    SplashLogo->setMargin( 0 );
    SplashLogo->setMidLineWidth( 0 );
    SplashLogo->setPixmap( image0 );
    SplashLogo->setScaledContents( FALSE );
    SplashLogo->setIndent( 0 );

    SplashLayout->addWidget( SplashLogo, 1, 0 );
*/
    LoadingLabel = new QLabel( this, "LoadingLabel" );
    LoadingLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)0, LoadingLabel->sizePolicy().hasHeightForWidth() ) );
    LoadingLabel->setText( tr( "Loading... " ) );
    LoadingLabel->setAlignment( int( QLabel::AlignCenter ) );
    QFont LoadingLabel_font( QApplication::font() );
    LoadingLabel_font.setPointSize( 10 );
    LoadingLabel_font.setBold( FALSE );
    LoadingLabel->setFont( LoadingLabel_font );

    SplashLayout->addWidget( LoadingLabel, 2, 0 );

    ProgressBar = new QProgressBar( this, "ProgressBar" );
/*
    ProgressBar->setFrameShape( QFrame::NoFrame );
    ProgressBar->setFrameShadow( QFrame::Plain );
    ProgressBar->setMargin( 0 );
    ProgressBar->setFrameStyle( QFrame::NoFrame );
*/
    ProgressBar->setTotalSteps( 56 );
    ProgressBar->setProgress( 0 );
    QFont ProgressBar_font( ProgressBar->font() );
    ProgressBar_font.setPointSize( 10 );
    ProgressBar_font.setBold( FALSE );
    ProgressBar->setFont( ProgressBar_font );
    
    SplashLayout->addWidget( ProgressBar, 3, 0 );

    QDesktopWidget *qd = QApplication::desktop();
    QRect qr = qd->screenGeometry( qd->primaryScreen() );
    setGeometry( qr.right()/2 - 125, qr.bottom()/2 - 165, 250, 330 );
    updateGeometry();

    ProgressBar->setBackgroundOrigin( ParentOrigin );
    LoadingLabel->setBackgroundOrigin( ParentOrigin );
    //SplashLogo->setBackgroundOrigin( ParentOrigin );
    TitleLabel->setBackgroundOrigin( ParentOrigin );      
}

/*  
 *  Destroys the object and frees any allocated resources
 */
Splash::~Splash()
{
    // no need to delete child widgets, Qt does it all for us	
}

bool Splash::event( QEvent* ev )
{
    bool ret = QWidget::event( ev );
    if ( ev->type() == QEvent::ApplicationFontChange )
    {
        QFont TitleLabel_font( TitleLabel->font() );
        QFont LoadingLabel_font( LoadingLabel->font() );
        TitleLabel_font.setPointSize( 12 );
        LoadingLabel_font.setPointSize( 10 );
        TitleLabel->setFont( TitleLabel_font ); 
        LoadingLabel->setFont( LoadingLabel_font );
    }
    return ret;
}

void Splash::UpdateSplash( int i, QString s )
{
	qApp->processEvents();
	if ( s != "" )
	{
		//qApp->processOneEvent();
     	LoadingLabel->setText( s );
	}
	ProgressBar->setProgress( i );
}

void Splash::Close()
{
	QTimer *timer = new QTimer( this );
	connect( timer, SIGNAL(timeout()), this, SLOT(Delete()) );
	timer->start( 2000, TRUE );
}

void Splash::Delete()
{
 	delete this;
	//showMinimized();
}

void Splash::closeEvent ( QCloseEvent *e )
{
	Delete();
}
